// Nalozimo funkciji ResiSLE in IzracunajRMS iz datoteke l2-2.sci
exec('/pot-do-datotek/l2-2.sci')
// stevilo tock
n=11;
deltax=1/(n-1);
// stevilo enacb
neq=n-2;
// sistemska matrika
A=zeros(neq,neq);
// vektor neznank
u=zeros(neq,1);
// zacetni priblizek
zp=zeros(neq,1);
// vektor na desni
rhs=zeros(neq,1);
// Robna pogoja
u0=0;
u1=1;
//Peclejevo stevilo
Pe=10;
c=Pe*deltax/2;
// sestavimo vektor na desni strani
rhs  (1)=(1+c)*u0;
rhs(neq)=(1-c)*u1;
// sestavimo sistemsko matriko
//prva vrsta
A(1,1)=2;
A(1,2)=c-1;
// vrste vmes
for i=2:neq-1
    A(i,i-1)=-1-c;
    A(i,i)=2;
    A(i,i+1)=c-1;  
end
//zadnja vrsta
A(neq,neq)=2;
A(neq,neq-1)=-1-c;
// natancnost
eps=1.0E-7;
//resimo sistem enacb A*u=rhs
u = ResiSLE(A,zp,rhs,eps,neq);
// Naredim nov vektor s celo resitvijo
uu=zeros(n,1);
anal=zeros(n,1);
iks=zeros(n,1);
uu(1)=u0;
iks(1)=0;
anal(1)=0;
for i=2:n-1
  uu(i)=u(i-1);
  iks(i)=(i-1)/(n-1);
  anal(i)=(1-exp(Pe*iks(i)))/(1-exp(Pe));
end
uu(n)=u1;
anal(n)=u1;
iks(n)=1;
// RMS razlika
disp("RMS razlika="+string(IzracunajRMS(uu,anal,n)))
disp("delta x="+string(deltax))
disp("c="+string(c))
disp("n="+string(n))
// Izris grafa na ekran
plot(iks,uu)
plot(iks,anal,"dr")
b=get("current_axes");
b.title.font_size=4;
b.x_label.font_size=4;
b.y_label.font_size=4;
b.font_size=4;
b.data_bounds=[-0.01 1.01 -0.01 1.01];
legend("izracunano","analiticno",2);
xtitle("Difuzivno-konvektivna enacba","x","u")


