// Nalozimo funkciji ResiSLE in IzracunajRMS iz datoteke l2-2.sci
exec('/pot-do-datotek/l2-2.sci')
// stevilo tock
n=21;
deltax=1/(n-1)*%pi/4;
// stevilo enacb
neq=n-2;
// sistemska matrika
A=zeros(neq,neq);
// vektor neznank
u=zeros(neq,1);
// zacetni priblizek
zp=zeros(neq,1);
// vektor na desni
rhs=zeros(neq,1);
// Robna pogoja
u0=1;
u1=cos(%pi**2/16);
// ustvarimo iks, ci in analiticno resitev
iks=zeros(n,1);
ci=zeros(n,1);
anal=zeros(n,1);
for i=1:n
  iks(i)=(i-1)/(n-1)*%pi/4;
  ci(i)=(2*iks(i)**2+tan(iks(i)**2))*deltax**2;
  anal(i)=cos(iks(i)**2);
end
// sestavimo vektor na desni strani
rhs  (1)=-u0;
rhs(neq)=-u1;
// sestavimo sistemsko matriko
//prva vrsta
A(1,1)=-2*(1-ci(1+1));
A(1,2)=1;
// vrste vmes
for i=2:neq-1
    A(i,i-1)=1;
    A(i,i)=-2*(1-ci(i+1));
    A(i,i+1)=1;  
end
//zadnja vrsta
A(neq,neq)=-2*(1-ci(neq+1));
A(neq,neq-1)=1;
// natancnost
eps=1.0E-7;
//resimo sistem enacb A*u=rhs
u = ResiSLE(A,zp,rhs,eps,neq);
// Naredim nov vektor s celo resitvijo
uu=zeros(n,1);
uu(1)=u0;
for i=2:n-1
  uu(i)=u(i-1);
end
uu(n)=u1;
// RMS razlika
disp("RMS razlika="+string(IzracunajRMS(uu,anal,n)))
disp("delta x="+string(deltax))
disp("n="+string(n))
// Izris grafa na ekran
plot(iks,uu)
plot(iks,anal,"dr")
b=get("current_axes");
b.title.font_size=4;
b.x_label.font_size=4;
b.y_label.font_size=4;
//b.data_bounds=[-0.01 1.01 -0.01 1.01];
legend("izracunano","analiticno",1);
xtitle("Enacba nihanja","x","u")