// Nalozimo funkcijo ResiSLE iz datoteke l2-2.sci
exec('/pot-do-datotek/l2-2.sci')

// stevilo tock
n=11;

// znana sta robna pogoja na levi in desni zato stevilo enacb za 2 manjse
neq=n-2;

// sistemska matrika
A=zeros(neq,neq);

// vektor neznank
x=zeros(neq,1);
// zacetni priblizek
x0=zeros(neq,1);

// vektor na desni
rhs=zeros(neq,1);

// Robna pogoja
T0=20;
T1=40;

// sestavimo vektor na desni strani
rhs(1)=-T0*(1+1/( 2*(2+neq)));
rhs(neq)=-T1*(1-1/( 2*(neq+1+neq)));

// sestavimo sistemsko matriko
//prva vrsta
A(1,1)=-2;
A(1,2)=1-1/( 2*(2+neq));
// vrste vmes
for i=2:neq-1
    A(i,i-1)=1-1/( 2*(i+1+neq));
    A(i,i)=-2;
    A(i,i+1)=1+1/( 2*(i+1+neq));  
end
//zadnja vrsta
A(neq,neq)=-2;
A(neq,neq-1)=1+1/( 2*(neq+1+neq));

// natancnost
eps=1.0E-7;

//resimo sistem enacb A*x=rhs
x = ResiSLE(A,x0,rhs,eps,neq);

// Naredim nov vektor s celo resitvijo
T=zeros(n,1);
iks=zeros(n,1);
anal=zeros(n,1);
T(1)=T0;
iks(1)=1;
anal(1)=T0;
for i=2:n-1
  T(i)=x(i-1);
  iks(i)=1+(i-1)/(n-1);
  anal(i)=T0+(T1-T0)*log(iks(i))/log(2);
end
T(n)=T1;
iks(n)=2;
anal(n)=T1;

// primerjava temperature v sredini stene
i=n/2+1;
disp("x= "+string(iks(i)))
disp("izracunano= "+string(T(i)))
disp("analiticno= "+string(anal(i)))
disp("n= "+string(n))

// Izris grafa na ekran
plot(iks,T)
b=get("current_axes");
b.title.font_size=4;
b.x_label.font_size=4;
b.y_label.font_size=4;
b.font_size=4;
xtitle("Prevod toplote skozi nehomogeno steno","x","Temperatura")
