// Nalozimo funkcijo ResiSLE iz datoteke l2-2.sci
exec('/pot-do-datotek/l2-2.sci');
// Funkcija, ki izvede direktno polinomsko interpolacijo
function v = DPI(x,a,npe) 
  v=0;
  for i=1:npe
    v=v+a(i)*x**(i-1)
  end
endfunction
// Odvod, izracunan z odvajanjem polinoma
function v = odvodDPI(x,a,npe) 
  v=0;
  for i=2:npe
    v=v+(i-1)*a(i)*x**(i-2)
  end
endfunction

// stevilo tock (n+1)
npe=4;
// definiramo pare tock
x = [  1 ;  2 ;   3 ;   4 ];
f = [  3 ;  2 ;  11 ;  36 ];
// pripravimo sistem enacb za koeficiente
// resitev in zacetni priblizek resitve
a=zeros(npe,1);
a0=zeros(npe,1);
// sistemska matrika
A=zeros(npe,npe);
for i=1:npe
  for j=1:npe
    A(i,j)=x(i)**(j-1);
  end
end
// natancnost
eps=1.0E-10;
// resimo sistem enacb     
a = ResiSLE(A,a0,f,eps,npe); 
// izpis
disp("Koeficienti a(i)=") 
disp(a)
// Izvedemo interpolacijo za x=1.5,2.5,3.5
disp("f(1.5)="+string(DPI(1.5,a,npe))+"    df/dx(1.5)="+string(odvodDPI(1.5,a,npe)))
disp("f(2.5)="+string(DPI(2.5,a,npe))+"    df/dx(2.5)="+string(odvodDPI(2.5,a,npe)))
disp("f(3.5)="+string(DPI(3.5,a,npe))+"    df/dx(3.5)="+string(odvodDPI(3.5,a,npe)))