// Integracija (Trapez, Simpson, Gauss)

// definiramo funkcijo, ki jo integriramo
function fun = f(x)
  fun=cos(2*x)
endfunction

// meje integracije
a=2;
b=3;

// stevilo tock
N=2;

// analiticna resitev
anal=cos(b)*sin(b)-cos(a)*sin(a);

// Gaussove tocke in utezi
eta=zeros(N);
ome=zeros(N);
if ( N == 6 ) then
      eta(1)   = -0.9324695142031520;
      eta(2)   = -0.6612093864662645;
      eta(3)   = -0.2386191860831969;
      eta(4)  =  0.2386191860831971;
      eta(5)  =  0.6612093864662646;
      eta(6)  =  0.9324695142031521;
      ome(1)  =  0.1713244923791704;
      ome(2)  =  0.3607615730481386;
      ome(3)  =  0.4679139345726910;
      ome(4) =  0.4679139345726910;
      ome(5) =  0.3607615730481386;
      ome(6) =  0.1713244923791703;
elseif ( N == 4 ) then    
      eta(1)   = -0.8611363115940526;
      eta(2)   = -0.3399810435848563;
      eta(3)   =  0.3399810435848563;
      eta(4)   =  0.8611363115940526;
      ome(1)  =  0.3478548451374539;
      ome(2)  =  0.6521451548625462;
      ome(3)  =  0.6521451548625462;
      ome(4)  =  0.3478548451374539;
elseif ( N == 2 ) then        
      eta(1)   = -0.5773502691896258;
      eta(2)   =  0.5773502691896258;
      ome(1)  =  1.0000000000000000;
      ome(2)  =  1.0000000000000000;
else
      disp("Nepravilna izbira za N!")
end
    
// integracija po Gaussu
vsota=0;
for j=1:N
  vsota=vsota+ome(j)*f(a+(b-a)*(eta(j)+1)/2);
end
vsota=vsota*(b-a)/2;
disp("Gauss= "+string(vsota)+" Razlika="+string(abs(vsota-anal)))

// Trapezna shema
vsota=(f(a)+f(b))/2;
for j=1:N-1
  vsota=vsota+f(a+j*(b-a)/N);
end
vsota=vsota*(b-a)/N;
disp("Trapez= "+string(vsota)+" Razlika="+string(abs(vsota-anal)))

// Simpsonova shema
vsota=f(a)+f(b);
for j=1:N/2-1
  vsota=vsota+2*f(a+2*j*(b-a)/N);
end
for j=1:N/2
  vsota=vsota+4*f(a+(2*j-1)*(b-a)/N);
end
vsota=vsota*(b-a)/(3*N);
disp("Simpson= "+string(vsota)+" Razlika="+string(abs(vsota-anal)))

